#!/usr/bin/env python3

# File: tracking_intrinsics_gen.py
# Company: ModalAi, Inc.
# Author: Rich Martin (rich@modalai.com)
# Description: Generates an OpenCV tracking (VIO) camera instrinsics calibration yml file from
# the fisheye calibration YAML file generated by the ROS calibration tool.

# RGM NOTE:
# pip3 install the following:
# pip3 install ruamel.yaml
# pip3 install opencv-python

import sys
import argparse
import os.path
import numpy as np
import ruamel.yaml as yaml
import cv2

ros_default = "/tmp/calibrationdata/ost.yaml"
opencv_default = "opencv_tracking_intrinsics.yml"
show_file = True

parser = argparse.ArgumentParser(
    description='Generate OpenCV Tracking Camera Calibration File')
parser.add_argument('-r', '--ros', dest='ros_file', action='store',
                    default=ros_default,
                    help=f"ROS tracking camera calibration YAML input file. Default is {ros_default}")

parser.add_argument('-o', '--opencv', dest='opencv_file', action='store',
                    default=opencv_default,
                    help=f"OpenCV intrinsics calibration output file. Default is {opencv_default}")

args = parser.parse_args()

# check if files exist before continuing
opencv_file = args.opencv_file
ros_file = args.ros_file

print(f"Generating {opencv_file} . . .")

if not os.path.isfile(ros_file):
    sys.exit(args.ros_file + " file not found.")

cv_data = cv2.FileStorage(opencv_file, cv2.FILE_STORAGE_WRITE)

# read YAML calibration files
with open(ros_file, 'r') as f:
    try:
        ros_calib = yaml.safe_load(f)
    except yaml.YAMLError as exc:
        sys.exit(exc)

# RGM DEBUG
# print(ros_calib)

cv_data.write('M', np.reshape(ros_calib['camera_matrix']['data'], (3, 3)))
cv_data.write('D', np.array(ros_calib['distortion_coefficients']['data']))
cv_data.write('width', ros_calib['image_width'])
cv_data.write('height', ros_calib['image_height'])
cv_data.write('distortion_model', ros_calib['distortion_model'])

cv_data.release()

if show_file:
    os.system(f"cat  {opencv_file}")